merge with 0.30.213
[util-vserver.git] / scripts / vsomething
1 #! /bin/bash
2 # $Id: vsomething 2515 2007-03-18 15:32:22Z dhozac $
3
4 # Copyright (C) 2005 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
5 #  
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; version 2 of the License.
9 #  
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #  
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
18
19 : ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
20 test -e "$UTIL_VSERVER_VARS" || {
21     echo $"Can not find util-vserver installation (the file '$UTIL_VSERVER_VARS' would be expected); aborting..." >&2
22     exit 1
23 }
24 . "$UTIL_VSERVER_VARS"
25 . "$_LIB_FUNCTIONS"
26 . "$__PKGLIBDIR/vserver.functions"
27
28
29 function showHelp()
30 {
31     echo \
32 $"Usage: $0 [--quiet|-q] [--debug] <cmd> [--] <vserver-name>* [--all] -- <params>+
33
34 Execute <cmd> <vserver> <params>* foreach vserver.
35
36 Report bugs to <$PACKAGE_BUGREPORT>."
37     exit 0
38 }
39
40 function showVersion()
41 {
42     echo \
43 $"vsomething $PACKAGE_VERSION -- execute something for a set of vservers
44 This program is part of $PACKAGE_STRING
45
46 Copyright (C) 2005 Enrico Scholz
47 This program is free software; you may redistribute it under the terms of
48 the GNU General Public License.  This program has absolutely no warranty."
49     exit 0
50 }
51
52
53 is_quiet=
54 declare -a vservers=()
55
56 tmp=$(getopt -o +q --long help,version,debug,quiet -n "$0" -- "$@") || exit 1
57 eval set -- "$tmp"
58
59 while true; do
60     case "$1" in
61         (--help)        showHelp $0 ;;
62         (--version)     showVersion ;;
63         (--debug)       set -x;;
64         (--quiet|-q)    is_quiet=1 ;;
65         (--)            shift; break;;
66         (*)             echo $"vserver: internal error; arg=='$1'" >&2; exit 1;;
67     esac
68     shift
69 done
70
71 test "$#" -ge 1 || \
72     panic $"vsomething: no operation specified; try '--help' for more information"
73
74 cmd=$1
75 title=${VSOMETHING_TITLE:-$cmd}
76 shift
77
78 while test "$#" -ge 1; do
79     if getAllVserversByArg tmp "$1"; then
80         vservers=( "${vservers[@]}" "${tmp[@]}" )
81     else
82         case "$1" in
83             (--) shift; break;;
84             (*)  vservers=( "${vservers[@]}" "$1" )
85         esac
86     fi
87     shift
88 done
89
90
91 test "${#vservers[@]}" -ne 1 || is_quiet=1
92
93
94 cnt=0
95 res=255
96 for i in "${vservers[@]}"; do
97     cnt=$[ cnt + 1 ]
98
99     test -n "$is_quiet" || {
100         colorize bold echo -n "$title: operating on vserver "
101         colorize bold colorize emph echo "$i"
102         xtermTitle "$title: operating on vserver '$i'  [$cnt/${#vservers[@]}]"
103     }
104
105     if test -n "$VSOMETHING_PKGMGMT"; then
106         if pkgmgmt.isInternal "$i"; then
107             $_VSERVER "$i" exec "$cmd" "$@"
108         else
109             _setVserverDir "$i"
110             ( _generateChbindOptions "$VSERVER_DIR"
111               $_VSERVER "$i" status &> /dev/null && \
112                 CHBIND_CMD=( "$_CHBIND" "${CHBIND_OPTS[@]}" -- )
113               callInNamespace "$i" \
114                 "$_VNAMESPACE" --new -- \
115                 "${CHBIND_CMD[@]}" \
116                 "$VSOMETHING_WORKER" "$i" "$@" )
117         fi
118     else
119         "$cmd" "$i" "$@"
120     fi
121         
122     res=$?
123
124     test $res -eq 0 -o -n "$is_quiet" || {
125         colorize error echo -n $"$title failed on vserver '$i' with errorcode $res"
126         echo
127     }
128         
129     test -n "$is_quiet" || echo
130 done
131
132 test "$cnt" -ge 0 || warning $"No vservers specified"
133 exit $res